<template>
  <form action="#" class="rui-search-form" @submit.prevent="()=>{}">
    <input ref="field"
           v-model="buffer"
           type="search"
           :disabled="disabled"
           :placeholder="placeholder">
    <rui-button type="submit" :title="$t('rui.search.search')" icon="magnifying-glass" :disabled="disabled" />
  </form>
</template>

<script>
import { debounce } from 'debounce'
import RuiButton from '../Button/Button.vue'

/**
 * Simple search form with debounced `update` events.
 *
 * @bindValue tacos
 * @disableProps modelValue
 */
export default {
  name: 'RuiSearchForm',
  emits: [
    'update:modelValue',
  ],
  components: { RuiButton },
  props: {
    modelValue: { required: true, type: String },
    /** Whether to disable the inputs */
    disabled: { required: false, type: Boolean, default: false },
    /** Custom input placeholder */
    placeholder: { required: false, type: String, default: '' },
  },
  data () {
    return {
      buffer: this.modelValue,
    }
  },
  created () {
    this.$nextTick(() => { this.$refs.field.focus() })
  },
  watch: {
    buffer: debounce(function () {
      if (this.buffer === this.modelValue) return

      this.$emit('update:modelValue', this.buffer)
    }, 250),
    modelValue (newValue) {
      if (newValue !== this.buffer) this.buffer = newValue
    },
  },
}

</script>
